#include <fstream.h>  // TEST
#include <time.h>

#include "d_Loop.h"
#include "Iterative_Deepening.h"
#include "d_Util.h"

//-----------------------------------------------------------------------------------
/* ?    
 *     
 *
 *  ChessTerminator75
 *   20.10.2007
 *
 *  
 *        
*/
//---------------------------------------------------------------------------


//	===================================================================
//    ,  ,  
void Deepening(T_board_list_816 * board_list_816,short int depth,char three_position[],T_PV three_moves,int & nodes,double wtime,double btime, double winc,double binc,int movestogo,double movetime,bool infinite){


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
//#if TEST_L
// //   Test_Loop.open ("_TEST_LOOP.txt",ios::app);
//    Test_Loop.open ("_TEST_LOOP_Deepening.txt");
//#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
T_PV PV_current;//  
T_PV PV_best;   //  

int Alpha=9999999;
int Beta=-9999999;
short int br =0;//       

double time_terminate= -1.0;
double time_current= -1.0;

time_t start,end;//      


//> go btime 300000 wtime 300000 
// 5 min * 60 = 300 sek
//             
//     1000
//      
//  300       ..   40     60
//     5   
//
//

if (board_list_816->colour_move == 1){// 1-  2-  
  if (wtime!=-1) time_terminate= wtime/100;
}else{
  if (btime!=-1) time_terminate= btime/100;
}//if (board_list_816->colour_move == 1){

 if (movetime!=-1) time_terminate= movetime;

if (depth==-1) depth=5;
if (time_terminate!=-1) depth=20;
//  alloc = (time_max + inc * double(movestogo-1)) / double(movestogo);
if (infinite==true) depth=100;
time_current=0;
for (int d=1;((d<(depth+1))&&(br==0));d++){
  time (&start);
  nodes=0;
  Alpha_beta_816(-Beta,-Alpha,d,0,board_list_816,nodes,&PV_current,&PV_best,0,&three_moves,br);
  time (&end);
  time_current= difftime (end,start);
  if((time_terminate!=-1)&&(time_terminate<time_current)) break;
}//for (int d=1;d<(Depth_Max+1);d++){

//---------------------------------------------------------------------
//    < bestmove e2e4 
//     ( )  < bestmove d7d8N 
 cout <<"bestmove " <<x_to_notation(PV_best.initial_position[0]%16);
 cout <<(8-PV_best.initial_position[0]/16);
 cout <<x_to_notation(PV_best.final_position[0]%16);
 cout <<(8-PV_best.final_position[0]/16);
 //    
 if (PV_best.final_pawn[0] !=0) cout <<int_to_char_board(PV_best.final_pawn[0],2);
 cout <<"\n";
//---------------------------------------------------------------------


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
//#if TEST_L
//    Test_Loop.close();
//#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
}//void Loop(int chess_board[],int Depth_Max,int print_bestmove[],int Eval,int Nodes,int pv[]){
//	*******************************************************************