#include "d_Rules_Captures_816.h"
//-----------------------------------------------------------------------------------
/* ++
 *      
 *
 *  ChessTerminator75
 *   21.07.2007
 *
 *  
 *   
 *     d_Surplus_moves
 *         
 * (       .          )
*/

//---------------------------------------------------------------------------

//	===================================================================
//       8  16 
// 0- , 1-, 2-, 3-, 4-, 5-, 6-
//  : name- ,n- ,board_816-,list_surplus_moves-  
void Rules_captures_816(short int name,short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){

 switch (name){

   case 0 :
   // 
   break;

   case 1 : //
     Pawn_captures_816(n,board_list_816,list_surplus_moves);
   break;

   case 2 : //
     Rook_captures_816(n,board_list_816,list_surplus_moves);
   break;

   case 3 : //
     Knight_captures_816(n,board_list_816,list_surplus_moves);
   break;

   case 4 : //
     Bishop_captures_816(n,board_list_816,list_surplus_moves);
   break;

   case 5 : //
     Queen_captures_816(n,board_list_816,list_surplus_moves);
   break;

   case 6 : //
     King_captures_816(n,board_list_816,list_surplus_moves);
   break;

   default:;//   
   
 }// switch (name){
}//Rules_816(int name,int n,int board_816[],T_list_surplus_moves list_surplus_moves){

//	*******************************************************************

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//********************************************************************
//   Rook_816 Knight_816 Bishop_816 Queen_816             *
//      board_list_816.colour_figure_816[] *
//********************************************************************

//	===================================================================T
//     
//    
 void Rook_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
short int n_1;
//   -16    |     + 1    -> 
//   + 16    |     - 1     <-
short int dR[]={-16,1,16,-1};
short int p = list_surplus_moves->amount_moves; 

//    ..   
for (int i=0; i<4;i++){
  n_1 = n + dR[i];
//   --------------------------------------------------
//        ,      
  while ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){

	 if (board_list_816.colour_figure_816[n_1]==0){ 
	 }else{
       list_surplus_moves->name_figure[p]=2 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
	   list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1];  
       p=p+1;
	   break;//     
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
     n_1 = n_1 + dR[i];
  }//while (!(n_1 & 0*88)&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
//-----------------------------------------------------------------
}//for (int i=0; i<4;i++){
//    (     + )
//    20    20   21 ..   
list_surplus_moves->amount_moves=p;
 }//Rook_816(int n,int board_list_816.colour_figure_816[],T_list_surplus_moves list_surplus_moves){
//	*******************************************************************

//	===================================================================
//     
//    
 void  Bishop_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
short int n_1;
//   -15       + 17   
//   + 15        -17   
short int dB[]={-15,17,15,-17};
short int p = list_surplus_moves->amount_moves; 

for (int i=0; i<4;i++){
  n_1 = n + dB[i];
//        ,      ,
  while ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){

	 if (board_list_816.colour_figure_816[n_1]==0){
	 }else{
       list_surplus_moves->name_figure[p]=4 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
	   list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
       p=p+1;
	   break;//     
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
     n_1 = n_1 + dB[i];
  }//while (!(n_1 & 0*88)&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
}//for (i=1; i<5;i++){
list_surplus_moves->amount_moves=p;

}//Bishop_816(int n,int board_list_816.colour_figure_816[],T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************

//	===================================================================
//      
//    
 void  Queen_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
  char  n_1;
//   -16    |       -15    
//   + 1    ->   + 17   
//   + 16    |       + 15   
//   - 1     <-   -17   

short int dQ[]={-16,-15,1,17,16,15,-1,-17};
short int p = list_surplus_moves->amount_moves; 

for (int i=0; i<8;i++){
  n_1 = n + dQ[i];
//        ,      ,
  while ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){

	 if (board_list_816.colour_figure_816[n_1]==0){
	 }else{
       list_surplus_moves->name_figure[p]=5 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
	   list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
       p=p+1;
	   break;//     
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
     n_1 = n_1 + dQ[i];
  }//while (!(n_1 & 0*88)&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
}//for (i=1; i<5;i++){
list_surplus_moves->amount_moves=p;

}//void  Queen_816(int n,int board_list_816.colour_figure_816[],T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************

//	===================================================================
//      
//    
void  Knight_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
short int n_1;

//   - 33   2  1     - 31   2  1
//   - 14   2  1    + 18   2  1
//   + 33   2  1     + 31   2  1 
//   + 14   2  1      - 18   2  1

short int dK[]={-33,-31,-14,18,33,31,14,-18};
short int p = list_surplus_moves->amount_moves; 

for (int i=0; i<8;i++){
  n_1 = n + dK[i];
//        ,      ,
  if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){

	 if (board_list_816.colour_figure_816[n_1]==0){
	 }else{
       list_surplus_moves->name_figure[p]=3 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
	   list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
       p=p+1;
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
  }//if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
}//for (i=1; i<5;i++){
list_surplus_moves->amount_moves=p;


}//void  Knight_816(int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//****************************************************************
//   King_816                                         *
//     board_list_816.colour_figure_816[]    *
//****************************************************************

//	===================================================================
//     
//    
//    
void King_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
short int n_1;

//   - 16         - 15     
//   + 1         + 17     
//   + 16          + 15     
//   - 1          - 17     

short int dK[]={-16,-15,1,17,16,15,-1,-17};
short int p = list_surplus_moves->amount_moves; 

for (int i=0; i<8;i++){
  n_1 = n + dK[i];
//        ,      ,
  if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){

	 if (board_list_816.colour_figure_816[n_1]==0){
	 }else{
         list_surplus_moves->name_figure[p]=6 ;
	     list_surplus_moves->initial_position[p] = n;
	     list_surplus_moves->final_position[p] = n_1;
	     list_surplus_moves->description_move[p] =1;
         list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
         p=p+1;
	 }//if (board_list_816.colour_figure_816[n_1]!=0){ 
  }//if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
}//for (i=1; i<5;i++){

list_surplus_moves->amount_moves=p;
}//void King_816(int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//****************************************************************
//   Pawn_816                                         *
//     board_list_816.colour_figure_816[]    *
//                             *
//****************************************************************

//	===================================================================
//     
//    
void Pawn_captures_816(short int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
short int n_1;
short int p = list_surplus_moves->amount_moves; 
// 1   -----------------------------------------
//    
//  
if(board_list_816.colour_figure_816[n]==1){
 //----------------------------------------------------------------------------------
//   
 n_1 = n - 17;
 //               
 if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
    if (board_list_816.colour_figure_816[n_1]!=0){
       list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 

//     
//      8,     9,
//      10,     11,
	 if ((n_1/16)==0) {
	  list_surplus_moves->description_move[p] =8;
       p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
	 }//if ((n_1/16)==0) {
       p=p+1;
	}//if ((board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])&&(board_list_816.colour_figure_816[n_1]!=0)){
 }//if ((n_1>0)&&(board_list_816.colour_figure_816[n_1]!=3)){
 
 //----------------------------------------------------------------------------------
//   
 n_1 = n - 15;
 //               
 if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
    if (board_list_816.colour_figure_816[n_1]!=0){
       list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
//     
//      8,     9,
//      10,     11,
	 if ((n_1/16)==0)  {
	  list_surplus_moves->description_move[p] =8;
      p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
	 }//if ((n_1/16)==0) {
     p=p+1;
	}//if ((board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])&&(board_list_816.colour_figure_816[n_1]!=0)){
 }//if ((n_1>0)&&(board_list_816.colour_figure_816[n_1]!=3)){

//----------------------------------------------------------------------------------
//   
//     

 if(board_list_816.taking_passage_yes == 1){
//     
     n_1 = 16*board_list_816.taking_passage_y+board_list_816.taking_passage_x;
//             
	 if(((n-n_1)== 15)||((n-n_1)== 17)){
	   list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =2;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1+16]; 
       p=p+1;
	 }//if(((n-n_1)== 15)||((n-n_1)== 17)){
 }//if(board_list_816->taking_passage_yes == 1){

}//if(board_list_816.colour_figure_816[n]==1){

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  
if(board_list_816.colour_figure_816[n]==2){

 //----------------------------------------------------------------------------------
//    
 n_1 = n + 17;
 //               
 if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
    if (board_list_816.colour_figure_816[n_1]!=0){
       list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
//     
//      8,     9,
//      10,     11,
	 if ((n_1/16)==7)  {
	  list_surplus_moves->description_move[p] =8;
      p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
	 }//if ((n_1/16)==7) {
     p=p+1;
	}//if ((board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])&&(board_list_816.colour_figure_816[n_1]!=0)){
 }//if ((n_1>0)&&(board_list_816.colour_figure_816[n_1]!=3)){
 
 //----------------------------------------------------------------------------------
//   
 n_1 = n + 15;
 //               
 if ((!(n_1 & 0x88))&&(board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])){
    if (board_list_816.colour_figure_816[n_1]!=0){
       list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =1;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
//     
//      8,     9,
//      10,     11,
	 if ((n_1/16)==7)  {
	  list_surplus_moves->description_move[p] =8;
      p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1]; 
	 }//if ((n_1/16)==7) {
     p=p+1;
	}//if ((board_list_816.colour_figure_816[n]!=board_list_816.colour_figure_816[n_1])&&(board_list_816.colour_figure_816[n_1]!=0)){
 }//if ((n_1>0)&&(board_list_816.colour_figure_816[n_1]!=3)){

//----------------------------------------------------------------------------------
//   
//     
 if(board_list_816.taking_passage_yes == 1){
      n_1 = 16*board_list_816.taking_passage_y+board_list_816.taking_passage_x;
	 if(((n-n_1)== -15)||((n-n_1)== -17)){
	   list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =2;
       list_surplus_moves->name_taking_figure[p]=board_list_816.name_figure_816[n_1-16]; 
       p=p+1;
	 }//if(((n-n_1)== -15)||((n-n_1)== -17)){

 }//if(board_list_816.taking_passage_yes == 1){


}//if(board_list_816.colour_figure_816[n]==2){

list_surplus_moves->amount_moves=p;
}//Pawn_816(int n,T_board_list_816 board_list_816,T_list_surplus_moves * list_surplus_moves){
//	*******************************************************************


